import { Done } from '../../../../../Class/Functional/Done';
import { Fail } from '../../../../../Class/Functional/Fail';
import { Semifunctional } from '../../../../../Class/Semifunctional';
import { System } from '../../../../../system';
import { A } from '../../../../../types/interface/A';
export interface I<T> {
    a: A<T>;
    any: any;
}
export interface O<T> {
    first: T;
    done: any;
}
export default class Shift<T> extends Semifunctional<I<T>, O<T>> {
    constructor(system: System);
    f({ a }: I<T>, done: Done<O<T>>, fail: Fail): Promise<void>;
    b(): void;
}
